import argschema
from argschema.fields import Nested


class MultiStimulusRunningSpeedInputParameters(argschema.ArgSchema):
    output_path = argschema.fields.OutputFile(
        required=True,
        description="The location to write the output file"
    )

    mapping_pkl_path = argschema.fields.InputFile(
        required=True,
        help="path to pkl file containing raw stimulus information",
    )
    behavior_pkl_path = argschema.fields.InputFile(
        required=True,
        help="path to pkl file containing raw stimulus information",
    )
    replay_pkl_path = argschema.fields.InputFile(
        required=True,
        help="path to pkl file containing raw stimulus information",
    )
    sync_h5_path = argschema.fields.InputFile(
        required=True,
        help="path to h5 file containing synchronization information",
    )

    use_lowpass_filter = argschema.fields.Bool(
        required=True,
        default=True,
        description=(
            "apply a low pass filter to the running speed results"
            )
        )

    zscore_threshold = argschema.fields.Float(
        required=True,
        default=10.0,
        description=(
            "The threshold to use for removing outlier "
            "running speeds which might be noise and not true signal"
        )
    )


class MultiStimulusRunningSpeedOutputSchema(argschema.schemas.DefaultSchema):
    input_parameters = Nested(
        MultiStimulusRunningSpeedInputParameters,
        description=("Input parameters the module was run with"),
        required=True,
    )


class MultiStimulusRunningSpeedOutputParameters(
    MultiStimulusRunningSpeedOutputSchema
):
    output_path = argschema.fields.OutputFile(
        required=True,
        help="Filtered running speed hdf5 output file."
    )
