from allensdk.core.auth_config import LIMS_DB_CREDENTIAL_MAP, \
    MTRAIN_DB_CREDENTIAL_MAP
from allensdk.internal.api import db_connection_creator


class LimsTest:
    """Helper class for testing LIMS. For each test, checks whether
    bamboo is required and if so sets up a connection"""
    def setup_method(self, method):
        marks = getattr(method, 'pytestmark', None)
        if marks:
            marks = [m.name for m in marks]

            # Will only create a dbconn if the test requires_bamboo
            if 'requires_bamboo' in marks:
                self.dbconn = db_connection_creator(
                    fallback_credentials=LIMS_DB_CREDENTIAL_MAP)
                self.mtrainconn = db_connection_creator(
                    fallback_credentials=MTRAIN_DB_CREDENTIAL_MAP
                )
